/**************************************************************************/
/*!
	@file			stm32f0xx_io_view.c
	@author         Nemui Trinomius (http://nemuisan.blog.bai.ne.jp)
    @version        1.00
    @date           2012.05.30
	@brief          Debugging I/O Definitions For STM32F0 Devices.

    @section HISTORY
		2012.05.30	V1.00	Start Here.
		
    @section LICENSE
		BSD License. See Copyright.txt
*/
/********************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f0xx.h"

/* Defines -------------------------------------------------------------------*/
typedef union GPIODATA_t {

	__IO uint16_t DUMMY;
	struct {
		__IO	uint16_t DR_00:	1;
		__IO	uint16_t DR_01:	1;
		__IO	uint16_t DR_02:	1;
		__IO	uint16_t DR_03:	1;
		__IO	uint16_t DR_04:	1;
		__IO	uint16_t DR_05:	1;
		__IO	uint16_t DR_06:	1;
		__IO	uint16_t DR_07:	1;
		__IO	uint16_t DR_08:	1;
		__IO	uint16_t DR_09:	1;
		__IO	uint16_t DR_10:	1;
		__IO	uint16_t DR_11:	1;
		__IO	uint16_t DR_12:	1;
		__IO	uint16_t DR_13:	1;
		__IO	uint16_t DR_14:	1;
		__IO	uint16_t DR_15:	1;
	} b_DR;
} GPIODATA_t;


/* Constants -----------------------------------------------------------------*/
volatile ADC_TypeDef          * const IO_ADC1			__attribute__ ((section(".ioview"))) = ADC1;
volatile ADC_Common_TypeDef   * const IO_ADC			__attribute__ ((section(".ioview"))) = ADC;
volatile CRC_TypeDef          * const IO_CRC			__attribute__ ((section(".ioview"))) = CRC;
volatile COMP_TypeDef         * const IO_COMP			__attribute__ ((section(".ioview"))) = COMP;
volatile CEC_TypeDef          * const IO_CEC			__attribute__ ((section(".ioview"))) = CEC;
volatile DAC_TypeDef          * const IO_DAC			__attribute__ ((section(".ioview"))) = DAC;
volatile DBGMCU_TypeDef       * const IO_DBGMCU			__attribute__ ((section(".ioview"))) = DBGMCU;
volatile DMA_TypeDef          * const IO_DMA1			__attribute__ ((section(".ioview"))) = DMA1;
volatile DMA_Channel_TypeDef  * const IO_DMA1_Channel1	__attribute__ ((section(".ioview"))) = DMA1_Channel1;
volatile DMA_Channel_TypeDef  * const IO_DMA1_Channel2	__attribute__ ((section(".ioview"))) = DMA1_Channel2;
volatile DMA_Channel_TypeDef  * const IO_DMA1_Channel3	__attribute__ ((section(".ioview"))) = DMA1_Channel3;
volatile DMA_Channel_TypeDef  * const IO_DMA1_Channel4	__attribute__ ((section(".ioview"))) = DMA1_Channel4;
volatile DMA_Channel_TypeDef  * const IO_DMA1_Channel5	__attribute__ ((section(".ioview"))) = DMA1_Channel5;
volatile EXTI_TypeDef         * const IO_EXTI			__attribute__ ((section(".ioview"))) = EXTI;
volatile FLASH_TypeDef        * const IO_FLASH			__attribute__ ((section(".ioview"))) = FLASH;
volatile OB_TypeDef       	  * const IO_OB     		__attribute__ ((section(".ioview"))) = OB;
volatile GPIO_TypeDef         * const IO_GPIOA			__attribute__ ((section(".ioview"))) = GPIOA;
volatile GPIODATA_t           * const IO_GPIOA_ODR      __attribute__ ((section(".ioview"))) = (GPIODATA_t *)&GPIOA->ODR;
volatile GPIO_TypeDef         * const IO_GPIOB			__attribute__ ((section(".ioview"))) = GPIOB;
volatile GPIODATA_t           * const IO_GPIOB_ODR      __attribute__ ((section(".ioview"))) = (GPIODATA_t *)&GPIOB->ODR;
volatile GPIO_TypeDef         * const IO_GPIOC			__attribute__ ((section(".ioview"))) = GPIOC;
volatile GPIODATA_t           * const IO_GPIOC_ODR      __attribute__ ((section(".ioview"))) = (GPIODATA_t *)&GPIOC->ODR;
volatile GPIO_TypeDef         * const IO_GPIOD			__attribute__ ((section(".ioview"))) = GPIOD;
volatile GPIODATA_t           * const IO_GPIOD_ODR      __attribute__ ((section(".ioview"))) = (GPIODATA_t *)&GPIOD->ODR;
volatile I2C_TypeDef          * const IO_I2C1			__attribute__ ((section(".ioview"))) = I2C1;
volatile I2C_TypeDef          * const IO_I2C2			__attribute__ ((section(".ioview"))) = I2C2;
volatile IWDG_TypeDef         * const IO_IWDG			__attribute__ ((section(".ioview"))) = IWDG;
volatile PWR_TypeDef          * const IO_PWR			__attribute__ ((section(".ioview"))) = PWR;
volatile RCC_TypeDef          * const IO_RCC			__attribute__ ((section(".ioview"))) = RCC;
volatile RTC_TypeDef          * const IO_RTC			__attribute__ ((section(".ioview"))) = RTC;
volatile SPI_TypeDef          * const IO_SPI1			__attribute__ ((section(".ioview"))) = SPI1;
volatile SPI_TypeDef          * const IO_SPI2			__attribute__ ((section(".ioview"))) = SPI2;
volatile SYSCFG_TypeDef       * const IO_SYSCFG			__attribute__ ((section(".ioview"))) = SYSCFG;
volatile TIM_TypeDef          * const IO_TIM1			__attribute__ ((section(".ioview"))) = TIM1;
volatile TIM_TypeDef          * const IO_TIM2			__attribute__ ((section(".ioview"))) = TIM2;
volatile TIM_TypeDef          * const IO_TIM3			__attribute__ ((section(".ioview"))) = TIM3;
volatile TIM_TypeDef          * const IO_TIM6			__attribute__ ((section(".ioview"))) = TIM6;
volatile TIM_TypeDef          * const IO_TIM14			__attribute__ ((section(".ioview"))) = TIM14;
volatile TIM_TypeDef          * const IO_TIM15			__attribute__ ((section(".ioview"))) = TIM15;
volatile TIM_TypeDef          * const IO_TIM16			__attribute__ ((section(".ioview"))) = TIM16;
volatile TIM_TypeDef          * const IO_TIM17			__attribute__ ((section(".ioview"))) = TIM17;
volatile TSC_TypeDef          * const IO_TSC			__attribute__ ((section(".ioview"))) = TSC;
volatile USART_TypeDef        * const IO_USART1			__attribute__ ((section(".ioview"))) = USART1;
volatile USART_TypeDef        * const IO_USART2			__attribute__ ((section(".ioview"))) = USART2;
volatile WWDG_TypeDef         * const IO_WWDG			__attribute__ ((section(".ioview"))) = WWDG;

/* Variables -----------------------------------------------------------------*/

/* Prototypes ----------------------------------------------------------------*/

/* Functions -----------------------------------------------------------------*/

/* End Of File ---------------------------------------------------------------*/
