/*
#
# Copyright (C) 2010-2012, audin
# 2011/04, 2012/11
# 2010/11
# http://avr.paslog.jp
# This file is licensed under the MIT License.
#
*/

//#include "hw_config.h"
#include "os.h"
#include "led_tsk.h"
#include "stm32f0xx.h"
#include "gpio.h"

#define LED3_PIN	23
#define LED4_PIN	22
#define LED_D3_ON()		digitalWrite(LED3_PIN, 1)
#define LED_D3_OFF()	digitalWrite(LED3_PIN, 0)
#define LED_D4_ON()		digitalWrite(LED4_PIN, 1)
#define LED_D4_OFF()	digitalWrite(LED4_PIN, 0)

#define led1_on()		LED_D3_ON()	/* Reverse */
#define led1_off()		LED_D3_OFF()
#define led2_on()		LED_D4_ON()
#define led2_off()		LED_D4_OFF()

int sio_get_led_blink_speed( void );

static int max_val	= 0;
static int val		= 0;

/*******************

* LED1  初期化
  
 *******************/
void led_init(void)
{
	pinMode(LED3_PIN, OUTPUT);
  	led1_off();									/*  最初はOFF	*/
}

/*******************

* Fake PWM
 
 *******************/
static void pwm( int ms )
{
	led1_on();
	wait( ms );
	led1_off();
	wait( max_val - val);
}

/*******************

* LED  点滅タスク1
  
 *******************/
void led_task(void)
{
	led_tsk( (void *)0 );	/* Just stub */
}

void led_tsk( task_arg_type pvParameters )
{
	( void ) pvParameters;								// not used
	led_init();											// LEDポート初期化
	const int MIN_VAL	= 0;
	static int dir		= 1;
	while( 1 ){
		if( ( val >= max_val) || ( val <= MIN_VAL) ){
			max_val = sio_get_led_blink_speed() + 3 ;	// LED点滅周期の変更
			max_val <<= 1;								// 時間をテキトウに調整
			if( val <= MIN_VAL ){
				dir = 1;
				wait( 1000 );							// 明るさ０になったら、1秒待つ
			}
			else{ 
				dir = -1;
				val = max_val;
			}
		}
		val += dir;
		pwm( val );
	}
}

/*******************

* LED2  初期化

 *******************/
void led2_init( void )
{
	pinMode(LED4_PIN, OUTPUT);
  	led2_off();									/*  最初はOFF	*/
}

/*******************

* LED2  点滅タスク2

 *******************/
void led2_task( void ){
	led2_tsk( (task_arg_type)0 );
}
void led2_tsk( task_arg_type arg )
{
	led2_init();
	while( 1 ){
		led2_on();
		wait( 2000 );
		led2_off();
		wait( 2000 );
	}
}

