/*
# Copyright (C) 2012 audin.
# 2012/11
# http://avr.paslog.jp
# This file is licensed under the MIT License.
*/
#include "os.h"

/* Includes ------------------------------------------------------------------*/
//#include "hw_config.h"
#include "led_tsk.h"
#include "sio_tsk.h"
//#include "arduino.h"

/* Includes ------------------------------------------------------------------*/
#include "stm32f0xx_gpio.h"
#include "utilities.h"
#include "gpio.h"
#include "serial.h"

/* Exported constants --------------------------------------------------------*/
#define PWM_PIN_3  3

/* Defines -------------------------------------------------------------------*/

/* Variables -----------------------------------------------------------------*/

/* Constants -----------------------------------------------------------------*/

/* Function prototypes -------------------------------------------------------*/

void pwm_task( void );
int _putchar(int chr);
/* Functions -----------------------------------------------------------------*/

/*******************

 * pwm_task
  
 *******************/
void pwm_tsk( void const *arg ){
	pwmFrequency( PWM_PIN_3, 1000); //set pwm frequencies 1000Hz
	while(1){
		for(int i=0;i<=100; i++){
			analogWrite(PWM_PIN_3,i);
			wait(9);
		}
		wait(1000);
		for(int i=100;i>=0; i--){
			analogWrite(PWM_PIN_3,i);
			wait(9);
		}
		wait(1000);
	}
}
void pwm_task( void )
{
	pwm_tsk( (void*)0 );
}

/*******************

 * UART_putc
  
 *******************/
void UART_putc( uint8_t c )
{
	_putchar( c );
	wait(70);			/* for demonstration */
}
/*******************

 * ticks_callback
  
 *******************/
#if 0
void ticks_callback (void const *arg)
{
	ticks++; 
	if(G_tickValue)
		G_tickValue--;
	wait(1);
}
#endif

/*******************

 * _pre_main			called from startup routin 
  
 *******************/
#ifdef __RTX_OS__
	void WEAK _init(void){ /* dummy */ }
	extern void WEAK __libc_init_array (void);
	extern osThreadDef_t os_thread_def_main; 
	__attribute ((noreturn)) void _pre_main (void)
	{
		if( __libc_init_array){
			__libc_init_array();
		}

		osKernelInitialize();						/* RTX OS kernel init	*/
		osThreadCreate(&os_thread_def_main, NULL);	/* Create main task		*/
		osKernelStart();							/* Kernel start			*/
		for (;;);
	}
#else
	int main(void);
	__attribute ((noreturn)) void _pre_main (void){ 
		main();
		while( 1 );
	}
#endif


#ifdef __RTX_OS__
osThreadDef ( led_tsk, osPriorityNormal, 1, 0);				// 
osThreadDef ( led2_tsk, osPriorityNormal, 1, 0);			// 
osThreadDef ( pwm_tsk, osPriorityNormal, 1, 0);				// 
osThreadDef ( sio_key_input_tsk, osPriorityNormal, 1, 0);	// 
//osThreadDef ( ticks_callback, osPriorityNormal, 1, 0);	// 
//osTimerDef (Timer1, ticks_callback ); 

osThreadId led_task_id, led2_task_id, pwm_task_id, key_task_id, ticks_callback_id;
#endif

/*******************

 * setup
  
 *******************/
void setup( void )
{
#ifdef __SCHEDULER__
	scheduler_init();
	scheduler_startLoop( led_task );			/* task 1 */
	scheduler_startLoop( led2_task );			/* task 2 */
	scheduler_start( pwm_task );				/* task 3 */
	scheduler_start( sio_key_input_task );		/* task 4 */
#endif

#ifdef __XPRINTF__
	xfunc_out = UART_putc;  /* connect PutChar function to xprintf() */
#endif
	Serial.begin( 38400 ); // USART2 ( TX=PA2, RX=PA3 )
	
}

/*******************
 
 * loop
 
*******************/
void loop( void )
{

#ifdef __RTX_OS__
	//	osTimerId tid		= osTimerCreate (osTimer(Timer1), osTimerPeriodic, 0);
	//	ticks_callback_id	= osThreadCreate( osThread( ticks_callback ) ,NULL  );	
	led_task_id  = osThreadCreate( osThread( led_tsk )			 ,NULL );	/* task 1 */
	led2_task_id = osThreadCreate( osThread( led2_tsk )			 ,NULL );	/* task 2 */
	pwm_task_id  = osThreadCreate( osThread( pwm_tsk )			 ,NULL );	/* task 3 */
	key_task_id  = osThreadCreate( osThread( sio_key_input_tsk ) ,NULL );	/* task 4 */
#endif

	sio_task();			/* task 5 (main task )*/
}

/* End Of File ---------------------------------------------------------------*/

