#ifndef __OS_H__
#define __OS_H__

#ifdef __RTX_OS__
#	include "cmsis_os.h"
#	define wait(n)		osDelay((n))
#	define yield()		osThreadYield()
#	ifndef WEAK
#		define WEAK __attribute__((weak))
#	endif
	typedef void const* task_arg_type;
#	define OS_NAME_STR	"RTX OS: BSD License version"
#	undef printf
#	define printf iprintf
#endif

#ifdef	__SCHEDULER__ 
#	include "Scheduler.h"
	typedef void* task_arg_type;
#	define OS_NAME_STR	"Simple Scheduler"
#endif


#ifdef __XPRINTF__
#	include "xprintf.h"
#	undef printf
#	define printf xprintf
#else
#	include <stdio.h>
#endif

#endif /* __OS_H__ */

