/*
#
# Copyright (C) 2010-2012, audin
# 2011/04, 2012/11
# 2010/11
# http://avr.paslog.jp
# This file is licensed under the MIT License.
#
*/

#include <stdint.h>
#include "os.h"
#include "led_tsk.h"
#include "sio_tsk.h"
#include "serial.h"


//#include "drv_uart.h"
#include "sio_tsk.h"
//#include "intr_uart.h"
#include "platform.h"



#ifndef __AVR__
#	define printf_P	printf
#endif



const char sOSName[]	= OS_NAME_STR;
const char sVersion[]	= "v0.1";
const char sCpu[]		= "STM32F0 Discovery (STM32F051R8T6)";
static int8_t state		= 0;

const char PROGMEM msg_clr[]	= /*  */ "\x1b[2J";	//clear 
const char PROGMEM msg_os[]		= /*  */ "%s, UART Transfer test. \n";
const char PROGMEM msg_cpu[]	= /*  */ "CPU may be %s or something.\n";
const char PROGMEM msg_wel[]	= /*  */ "Welcome !\n";
const char PROGMEM msg_bps[]	= /*  */ "UART speed is %u bps.\n"  ;
const char PROGMEM msg_led[]	= /*  */ "Now LED blink speed is %d.\n"  ;
const char PROGMEM msg_in[]		= /*  */ "\nPlease input LED blink speed [1 - 9]\n"  ;


static int led_blink_speed = 9; 



/*******************

* sio_Task
  
 *******************/
void sio_task( void ){
	sio_tsk( (void*)0 );	/* only stub */
}


extern int max_val;
void sio_tsk( task_arg_type pvParameters )
{
	( void ) pvParameters;	// not used

	while( 1 ){
		switch( state++ ){
		case -1:
			yield();							/* stop display */
			break;
		case 0:
			printf_P( msg_clr );				/* clear */
			wait( 2000 );						/* 2000[msec] */
			printf_P( msg_wel );
			wait( 2000 );
			break;
		case 1:
			//printf_P( msg_os, sVersion );
			printf_P( msg_os, sOSName );
			wait( 2000 );
			printf_P( msg_cpu, sCpu );
			wait( 2000 );
			break;
		case 2:
			//printf_P( msg_bps, ( unsigned int )uartDrv_getBaudrate() );
			//wait( 2000 );
			break;
		case 3:
			printf_P( msg_led, ( int )sio_get_led_blink_speed() );
			printf_P( msg_in );
			wait( 3000 );
			state = 0;
			break;
		}
	}
}

/*******************

* uartDrv_getchar
  
 *******************/
int uartDrv_getchar( void ){
	int res = 0;
	if( Serial.available() ){
		res = Serial.read();
	}
	return res;
}
/*******************

* sio_Key_Input_tsk
  
 *******************/
void sio_key_input_task( void ){
	sio_key_input_tsk( (void*)0 );	/* Just stub */
}

void sio_key_input_tsk( task_arg_type pvParameters )
{
	char c;
	( void ) pvParameters;	// not used

	while(1){
		//vTaskSuspend( NULL );		
		c = uartDrv_getchar();
		if( (c  >= '1') && ('9' >= c ) ){
			led_blink_speed = c - '0';
		}
		yield();
	}
}

/*******************

* sio_get_led_blink_speed
  
 *******************/
int sio_get_led_blink_speed(void)
{
	return (int)led_blink_speed;
}

/*******************

* sio_init
  
 *******************/
#if 0
void sio_init( UART_DEV_t dev, uint32_t baudrate)
{
	uartDrv_init( dev,  baudrate );
}
#endif



